/*
 ----------------------------------------------------------------------------
 === 3OS Kernel startup module ===
 ⮢    32 ࠧ來 饭 ०
 ----------------------------------------------------------------------------
*/

#include "CONF3OS.H"
#include "heap.hpp"
#include "kernel.hpp"
#include "dlcl\3osdlcl.hpp"

extern void     StartKernel(dword dwKeStart);

#pragma pack(1)
/* ਬ ⮪  -㧪 */
char KrnlStream[84];
/* ᮪ Loadable Kernel Module */
char LKM_example[138];

/*   */
c_Kernel *pc_Krnl3OS;

s_DLCL DLCLStorage[2]=
{
 {'LNRK',  NULL},
 {'TUOC',  NULL}
};

/*  ""  */
THeap *pc_Heap;


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   ⮢  樠樨   PM,
   ਭ:
      AX   ࠧ饭 ࠭ ⥪ 
      BX   砫 ࠭⢠ 
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
void __declspec(naked) StartPM(void){

// ન  ⥪ -  뢥 c  ࠭ 
 _asm{
  XOR  ESP, ESP
  MOV   SP, AX
  MOV   AX, 0x18
  MOV   SS, AX
  xor  EAX, EAX
  MOV   AX, BX
  PUSH EAX
  call StartKernel
 }
}

void StartKernel(dword dwKeStart){
 SETSEG(DS, k_GDKrnlData);      //  
 SETSEG(ES, k_GDKrnlData);      //  
 SETSEG(FS, k_GDKrnlFlat);      // 4Gb ᥣ 

//===> 樠 ""       ꥪ c_Heap
 pc_Heap = (THeap*) ((dword) &pc_Heap + sizeof(pc_Heap));
 pc_Heap->Init((void*)((dword)pc_Heap+sizeof(THeap)), 0x000a0000);

 pc_Krnl3OS = new c_Kernel((void*) dwKeStart);
 pc_Krnl3OS->Stabilize();
}